//+------------------------------------------------------------------+
//|                                     mt4tofile-2011-2012-v1.3.mq4 |
//|                                                   by: smallcat   |
//|                                                                  |
//| Need file :                                                      |
//|   "...\experts\indicators\SmallCatZzFractal-v1.1.ex4"            |
//|   "...\experts\indicators\Custom Zigzag.ex4"                     |
//|                                                                  |
//| put this file to : ".....\experts\scripts" folder                |
//| Allow DLL import at MT4, attach this script to EU M5 chart       | 
//| Get all candle information from EURUSD M5 from 2011-2012         |
//| see output file at: ".....\experts\files" folder                 |
//|                                                                  |
//| If all things going right, we can see file :                     |
//|   ....\experts\files\allcandles-2011-2012.csv                    |
//|                                                                  |
//| v1.3                                                             |
//|   *) adding: "candleUpDown = 2"                                  |
//|   *) bugs removed: curZZisUp / Down                              |
//|   *) adding: last ZZ end price                                   |
//+------------------------------------------------------------------+

#property copyright "SmallCat"
#property link      "SmallCat@ForexFactory"
//---
string          version        = "1.3";

//-- input parameters
extern int      ExtDepth       = 13;
extern int      ExtDeviation   = 8;
extern int      ExtBackstep    = 5;
extern double   distance       = 0.00018;  
extern string   startZZendInfo = "**IMPORTANT** this is the high/low of Zz End Prc BEFORE our very first candle";  
extern double   startZZendPrc  = 1.33287;    // low of "2011.01.02 21:00"
//---
int handle;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   //----- Open file, create data header ...
   handle=FileOpen("allcandles-2011-2012.csv",FILE_CSV|FILE_READ|FILE_WRITE,',');
   if(handle<1) {
      Comment("File allcandles-2011-2012.csv not found, the last error is ", GetLastError());
      return(false);
   }
   else {
      Comment("Open file allcandles-2011-2012.csv : Ok");
      Comment("1");
   }
   return(handle);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit(bool handle)  {
   FileClose(handle);
   return(0);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   int      i, tf = Period(), candleUpDown, fractal, zzId=0, curZzUpdown;
   string   curPair=Symbol(), tfText;
   datetime dateTime, dTime, nextbarTime;
   double   dOpen,dClose,dHigh,dLow;
   double   dHighPrev,dLowPrev,endZzPrc;
   double   upper_fractal, lower_fractal, upper_zigzag, lower_zigzag, upper_zigzagPrev, lower_zigzagPrev;
   bool     curZZisUp=false, curZZisDown=false;      
   
   for(i=iBars(curPair,tf); i>0; i--)  {
      dOpen       = iOpen(curPair,tf,i);
      dClose      = iClose(curPair,tf,i);
      dHigh       = iHigh(curPair,tf,i);
      dLow        = iLow(curPair,tf,i);
      dTime       = iTime(curPair,tf,i);
      dHighPrev   = iHigh(curPair,tf,i+1);
      dLowPrev    = iLow(curPair,tf,i+1);
      // candle
      if (dOpen > dClose) { candleUpDown = 0; }
      else if (dOpen == dClose) { 
         if ( MathAbs(dOpen-dHigh) > MathAbs(dOpen-dLow) ) {         // compare open to high & open to low
            candleUpDown = 1; 
         }
         else if ( MathAbs(dOpen-dHigh) < MathAbs(dOpen-dLow) ) {
            candleUpDown = 0; 
         }
         else {
            candleUpDown = 2;    // later change this to [0] or [1] manually / using other programming language
         }
      }
      else { candleUpDown = 1; }
      // fractal & ZZ
      upper_fractal        = iCustom(curPair,tf,"SmallCatZzFractal-v1.1",ExtDepth,ExtDeviation,ExtBackstep,distance,0,i); 
      lower_fractal        = iCustom(curPair,tf,"SmallCatZzFractal-v1.1",ExtDepth,ExtDeviation,ExtBackstep,distance,1,i); 
      upper_zigzag         = iCustom(curPair,tf,"SmallCatZzFractal-v1.1",ExtDepth,ExtDeviation,ExtBackstep,distance,2,i);  
      lower_zigzag         = iCustom(curPair,tf,"SmallCatZzFractal-v1.1",ExtDepth,ExtDeviation,ExtBackstep,distance,3,i); 
      upper_zigzagPrev     = iCustom(curPair,tf,"SmallCatZzFractal-v1.1",ExtDepth,ExtDeviation,ExtBackstep,distance,2,i+1);  
      lower_zigzagPrev     = iCustom(curPair,tf,"SmallCatZzFractal-v1.1",ExtDepth,ExtDeviation,ExtBackstep,distance,3,i+1); 
            
      // Get only candle from 2011 - 2012
      if ((dTime >= StrToTime("2011.01.02 21:05"))&&(dTime <= StrToTime("2012.12.31 23:59"))) { 
         if ((upper_fractal > 0)&&(lower_fractal == 0)) {
            fractal = 1;
         }
         else if ((upper_fractal == 0)&&(lower_fractal > 0)) {
            fractal = 0;
         }
         else if ((upper_fractal > 0)&&(lower_fractal > 0)) {
            fractal = 2;      // later change this to [01] or [10] manually / using other programming language
         }
         else {
            fractal = -1;
         }     
         
         //*******************************   
         // end of ZZleg is at prevBars   
         //*******************************   
         if (upper_zigzagPrev != 0)  {  
            zzId++;    
            curZZisUp      = false;
            curZZisDown    = true;
            endZzPrc       = dHighPrev;
         }
         else if (lower_zigzagPrev != 0) {
            zzId++;
            curZZisDown    = false;
            curZZisUp      = true;
            if (zzId == 1) {
               endZzPrc       = startZZendPrc;
            }
            else {
               endZzPrc       = dLowPrev;
            }
         }
         //---
         if (curZZisDown == true) {
            curZzUpdown = 0;
            if (dHigh != dLow) { // get only good data, remove bad data & write to file
               FileWrite(handle, curPair,getPeriodText(),TimeToStr(dTime, TIME_DATE|TIME_SECONDS),NormalizeDouble(dOpen, Digits),NormalizeDouble(dHigh, Digits),NormalizeDouble(dLow, Digits),NormalizeDouble(dClose, Digits),candleUpDown,fractal,zzId,curZzUpdown,endZzPrc);
            } // ende if (dHigh != dLow)
         }
         if (curZZisUp == true) {
            curZzUpdown = 1;
            if (dHigh != dLow) { // get only good data, remove bad data & write to file
               FileWrite(handle, curPair,getPeriodText(),TimeToStr(dTime, TIME_DATE|TIME_SECONDS),NormalizeDouble(dOpen, Digits),NormalizeDouble(dHigh, Digits),NormalizeDouble(dLow, Digits),NormalizeDouble(dClose, Digits),candleUpDown,fractal,zzId,curZzUpdown,endZzPrc);
            } // ende if (dHigh != dLow)
         }
      } // ende if ((dTime >= StrToTime("2011.01.02 21:05"))&&(dTime <= StrToTime("2012.12.31 23:59")))
   } // ende for 
   //---   
   return(0);
} // ende start

//+------------------------------------------------------------------+
string getPeriodText() {
   string periodText;
   switch (Period()) {
      case 1: periodText = "M1"; break;
      case 5: periodText = "M5"; break;
      case 15: periodText = "M15"; break;
      case 30: periodText = "M30"; break;
      case 60: periodText = "H1"; break;
      case 240: periodText = "H4"; break;
      case 1440: periodText = "D1"; break;
      case 10080: periodText = "W1"; break;
      case 43200: periodText = "MN1"; break;    
   }  
   return(periodText);
}

//+------------------------------------------------------------------+